package net.sf.alchim.codeplus.spoonprocessor;

import spoon.reflect.declaration.CtParameter;
import spoon.template.Parameter;
import spoon.template.Template;
import spoon.template.TemplateParameter;

public class NullParamTemplate implements Template {
    @SuppressWarnings("unused")
    @Parameter
    private String _paramName_;

    @Parameter
    private String _msg_;

    TemplateParameter<Object> _defaultExpr_;

    public NullParamTemplate(CtParameter<?> param, TemplateParameter<Object> defaultExpr) {
        _paramName_ = param.getSimpleName();
        _msg_ = param.getType().getSimpleName() + " " + param.getSimpleName() + " is null";
        _defaultExpr_ = defaultExpr;
    }

    public void check(Object _paramName_) {
        if (_paramName_ == null) {
            throw new IllegalArgumentException(_msg_);
        }
    }

    public void setDefault(Object _paramName_) {
        if (_paramName_ == null) {
            _paramName_ = _defaultExpr_.S();
        }
    }
}
